<?php
/*
	Class Name: Plugin Subpages
	Class URI: http://rmarsh.com/2008/03/27/plugin-settings-submenusplugin-settings-submenus/
	Description: A simple library class to ease the use of a further level of submenus in the admin pages
	Version 1.0.0
	Author: Rob Marsh, SJ
	Author URI: http://rmarsh.com/
*/

define('PLUGIN_SUBPAGES', true);

class PluginSubpages {
	var $pages = array();
	var $parent_page = '';
	var $current_page = array();

	function PluginSubpages() {
		$this->__construct();
	}	

	function __construct() {
		$parent_page = $_SERVER['QUERY_STRING'];
		$p1 = strpos($parent_page, 'page=');
		$p2 = strpos($parent_page, '&');
		if ($p2 === false) {
			$parent_page = substr($parent_page, $p1+5);
		} else {
			$parent_page = substr($parent_page, $p1+5, $p2-$p1-5);
		}
		$this->parent_page = $parent_page;
	}
	
	function add_subpage($title, $slug, $view) {
		$this->pages[] = array('title' => $title, 'slug' => $slug, 'view' => $view);
	}
	
	function page_from_slug($slug) {
		if (!isset($slug)) {
			return $this->pages[0];
		}
		foreach ($this->pages as $page) {
			if ($page['slug'] === $slug) {
				return $page;
			}
		}
		die('non-existent slug');
	}
	
	function display() {
		// sneakily steals and duplicates the admin submenu's CSS id
		echo "\n<ul id=\"submenu\" style=\"display: block\">\n"; // ... display: block handles the case where an admin menu replacement would make ours invisible
		$base = $_SERVER['PHP_SELF'] . '?page=' . $this->parent_page . '&subpage=';
		$this->current_page = $this->page_from_slug($_GET['subpage']);
		foreach($this->pages as $page) {	
			if($page === $this->current_page) {
				echo "<li><a href=\"$base{$page['slug']}\" class=\"current\">{$page['title']}</a></li>\n";
			} else {
				echo "<li><a href=\"$base{$page['slug']}\">{$page['title']}</a></li>\n";
			}
		}
		echo "</ul>\n";
		$this->current_page['view']();
	}
	
}

?>